/******************************************************************
 *
 *  Module:  ttime_test.c
 *
 *  Author:  SIS  1998
 *
 *  Description
 *
 *       This module provides the actuall user interface to the
 *       true time 560-5900 timer board. All this interface does
 *       for this release is give the user access to the memory
 *       space of the board.
 *
 ******************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include "ttime.h"
#include "ttime_api_extern.h"



main()
{

     int status;
     int input;
     char in_string[128]; 
     diag_reg_t diag_reg;
     conf_reg_t conf_reg;
     preset_time_reg_t preset_time;
     time_freeze_reg_t time_reg;
     int i;
     unsigned int *p_long_word;

     printf("...Beginning test....\n"); 
  
     status = init_560();

     if (status != 0)
       exit(-1); 
	 while (1)
	 {
         printf ("\n\n");
         printf ("    Select from the following functions:\n\n");
         printf ("    1   Read diagnostic register\n\n");
         printf ("    2   Start timer  \n\n");
         printf ("    3   Read timer  \n\n");
         printf ("    4   stop timer  \n\n");
         printf ("    5   read preset time  \n\n");
         printf ("    6   reset time  \n\n");
         printf ("    7   preset a time  \n\n");
         printf ("    20  exit \n\n");
    
		 scanf ("%d",&input);

         switch (input)
         {
         case 1:
            read_diag_reg(&diag_reg);
			printf ("error status = %x\n",diag_reg.err_stat);
			printf ("oscillator status =%x%x\n",diag_reg.ossillator_stat[0],
				                                diag_reg.ossillator_stat[1]);
			break;
	 case 2:
		 read_conf_reg (&conf_reg);

                 p_long_word = (unsigned int *)&conf_reg;

		 printf ("config register = %x\n",*p_long_word);

		 conf_reg.gen_stp_run = 0; /* start generator */

		 write_conf_reg (&conf_reg);
		 break;
	case 3:
		 printf("OK prepare to hang......\n\n");
		 while (1)
		 {
		         read_time_freeze_reg(&time_reg);
			 printf ("time is %2x:%2x:%2x:%2x:%2x:%2x:%2x:%2x:\r",
				 time_reg.tens_unit_hours,
				 time_reg.tens_unit_min,
				 time_reg.tens_unit_sec,
				 time_reg.hun_tens_ms,
				 time_reg.reserved_3,
				 time_reg.hw_stat,
				 time_reg.unit_ms_hun_us,
				 time_reg.tens_unit_us);
                                /*
                                i = 0;
                                while (i< 100000)
                                    i++;
                                 */
		 }
                 break;
         case 4:
		 read_conf_reg (&conf_reg);

                 p_long_word = (unsigned int *)&conf_reg;

		 printf ("config register = %x\n",*p_long_word);

		 conf_reg.gen_stp_run = 1; /* stop generator */
		 conf_reg.mode_sel = 0;    /* select generator mode */

                 printf ("writing %x to config register\n",*p_long_word);

		 write_conf_reg (&conf_reg);

		 break;
         case 5:
	         read_preset_time_reg (&preset_time);
                 printf("preset time is %2x:%2x:%2x:%2x:%2x:%2x:%2x:%2x:%2x:\n",
			 preset_time.thou_hun_years,
			 preset_time.tens_unit_years,
			 preset_time.hun_days,
			 preset_time.tens_unit_days,
			 preset_time.tens_unit_hours,
			 preset_time.tens_unit_min,
			 preset_time.tens_unit_sec,
			 preset_time.hun_ten_ms,
			 preset_time.unit_ms);
                 break;
         case 6:
		
		 preset_time.thou_hun_years = 0;
		 preset_time.tens_unit_years = 0;
		 preset_time.hun_days = 0;
		 preset_time.tens_unit_days = 0;
		 preset_time.tens_unit_hours = 0;
		 preset_time.tens_unit_min = 0;
		 preset_time.tens_unit_sec = 0;
		 preset_time.hun_ten_ms = 0;
		 preset_time.unit_ms = 0;
  
                 write_preset_time_reg (&preset_time);

		 read_conf_reg (&conf_reg);

                 p_long_word = (unsigned int *)&conf_reg;

		 printf ("config register = %x\n",*p_long_word);

		 conf_reg.preset_time_rdy = 1; /* load the time preset */

                 printf ("writing %x to config register\n",*p_long_word);

		 write_conf_reg (&conf_reg);

		 break;
         case 7:

		 preset_time.thou_hun_years = 0x11;
		 preset_time.tens_unit_years = 0x22;
		 preset_time.hun_days = 0x03;
		 preset_time.tens_unit_days = 0x44;
		 preset_time.tens_unit_hours = 0x55;
		 preset_time.tens_unit_min = 0x12;
		 preset_time.tens_unit_sec = 0x34;
		 preset_time.hun_ten_ms = 0x88;
		 preset_time.unit_ms = 0x99;
  
                 write_preset_time_reg (&preset_time);

		 read_conf_reg (&conf_reg);

                 p_long_word = (unsigned int *)&conf_reg;

		 printf ("config register = %x\n",*p_long_word);

		 conf_reg.preset_time_rdy = 1; /* load the time preset */

                 printf ("writing %x to config register\n",*p_long_word);

		 write_conf_reg (&conf_reg);

		 break;
         case 20:
             close_560();
			 exit(0);
             break;
         default:
             printf ("what are you kidding?????\n");
             break;
         } 
	 }
}
