/******************************************************************
 *
 *  Module:  ttime_test.c
 *
 *  Author:  SIS  1998
 *
 *  Description
 *
 *       This module provides the actuall user interface to the
 *       true time 560-5900 timer board. All this interface does
 *       for this release is give the user access to the memory
 *       space of the board.
 *
 ******************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/mman.h>
#include "ttime_api.h"



main()
{

     int status;
     int input, bit_num, bit_val;
     diag_reg_t diag_reg;
     conf_reg_t conf_reg;
     preset_time_reg_t preset_time, new_time;
     time_freeze_reg_t time_reg;
     time_cmp_reg_t compare_time;
     timespec_t sleep_time, act_time;
     int j,i;
     unsigned int *p_long_word;

     char in_string[128]; 
     printf("...Beginning test....\n"); 
  
     status = init_560();

     if (status != 0)
       exit(-1); 
	 while (1)
	 {
         printf ("\n\n");
         printf ("    Select from the following functions:\n\n");
         printf ("    1   Read diagnostic register           8 Read Config register\n\n");
         printf ("    2   Start timer                        9 Set Config register bits\n\n");
         printf ("    3   Set hardware control Register     10 Read Time\n\n");
         printf ("    4   stop timer                        11 Test Time Compare Event\n\n");
         printf ("    5   read preset time                  12 Test syncronization Process\n\n");
         printf ("    6   reset time                        13 reserved\n\n");
         printf ("    7   preset a time                     14 reserved\n\n");
         printf ("    20  exit \n\n");
    
	 scanf ("%d",&input);

         switch (input)
         {
         case 1:
	     read_diag_reg (&diag_reg);

             printf ("Diagnostic reg: err_stat: %x\n ossilator stat: %x%x",diag_reg.err_stat,
									   diag_reg.ossillator_stat[0],
									   diag_reg.ossillator_stat[1]);
 
	     break;
	 case 2:
                 write_conf_reg_bitfield (GEN_STOP_BIT, 0);
		 break;
	case 3:
		 printf("Enter BIT NUMBER and VALUE\n");

                 scanf("%d %d", &bit_num, &bit_val); 

                 write_hw_ctl_reg_bitfield (bit_num,bit_val);
                 break;
         case 4:
		
		 printf("case 4\n");

		 write_conf_reg_bitfield (GEN_STOP_BIT, 1);

		 break;
         case 5:
		 printf("case 5\n");
	         read_preset_time_reg (&preset_time);
                 break;
         case 6:
                 reset_time();
		 break;
         case 7:

                 new_time.hun_ms = 0;
                 new_time.tens_ms = 0;
                 new_time.unit_ms = 0;
                 new_time.tens_sec = 1;
                 new_time.unit_sec = 9;
                 new_time.tens_min = 5;
                 new_time.unit_min = 2;
                 new_time.tens_hour = 1;
                 new_time.unit_hour = 7;

                 new_time.tens_day = 0;
                 new_time.unit_day = 0;
                 new_time.hun_day = 0;
                 new_time.tens_year = 0;
                 new_time.unit_year = 0;
                 new_time.hun_year = 0;
                 new_time.thou_year = 0;

                 set_new_time (&new_time);

		 break;
	 case 8:
		 read_conf_reg (&conf_reg);

                 p_long_word = (unsigned int *)&conf_reg;

		 printf ("config register = %x\n",*p_long_word);

		 break;
	case 9:
		 printf("Enter BIT NUMBER and VALUE\n");

                 scanf("%d %d", &bit_num, &bit_val); 

                 write_conf_reg_bitfield (bit_num,bit_val);
                 break;
         case 10:
                 while(1)
                 {
                     snapshot_time(&time_reg);
                     printf ("time is %d%d hours %d%d min %d%d sec %d%d%d ms %d%d%d us\r",
                          time_reg.tens_hour,time_reg.unit_hour,
                          time_reg.tens_min,time_reg.unit_min,
                          time_reg.tens_sec,time_reg.unit_sec,
                          time_reg.hun_ms,time_reg.tens_ms,time_reg.unit_ms,
                          time_reg.hun_us,time_reg.tens_us,time_reg.unit_us);
                 }
                 break;
         case 11:

	     /*
              *  This test should generate an event every 10 seconds.
              */
             compare_time.hun_us = 0;
             compare_time.tens_us = 0;
             compare_time.unit_us = 0;
             compare_time.hun_ms = 9;
             compare_time.tens_ms = 0;
             compare_time.unit_ms = 0;
             compare_time.tens_sec = 0;
             compare_time.unit_sec = 0;
             compare_time.mask = 0x09;


             write_time_cmp_reg(&compare_time);

             /*
	      * Now loop and wait for an event
              */
             i = 0;
             while (i < 20)
             {
                 j = 0;
                 while(read_hw_stat_reg_bitfield(HW_STAT_TIME_CMP_PULSE_STAT) == 0 )
                 {
                     printf("waiting...\r"); 
                 }
                 printf ("time compare event number %d\r",i); 
                 i++;
                 /*  clear the event */
                 write_hw_ctl_reg_bitfield(HW_CTL_TIME_CMP_INT_CLEAR,1);
             }
             break;
         case 12:

	     printf ("Enter time interval to poll (in seconds): ");
             scanf ("%d",&i);
             printf ("Polling every %d seconds\n",i);
             while (1)
             {
                 sleep_time.tv_sec = i;
                 sleep_time.tv_nsec = i;
                 act_time.tv_sec = i;
                 act_time.tv_nsec = i;
                 j = nanosleep (&sleep_time,&act_time);
                 if (j != 0)
                    printf("there is a problem.....\n");
                 snapshot_time(&time_reg);
                 printf ("time is %d%d hours %d%d min %d%d sec %d%d%d ms %d%d%d us\r",
                          time_reg.tens_hour,time_reg.unit_hour,
                          time_reg.tens_min,time_reg.unit_min,
                          time_reg.tens_sec,time_reg.unit_sec,
                          time_reg.hun_ms,time_reg.tens_ms,time_reg.unit_ms,
                          time_reg.hun_us,time_reg.tens_us,time_reg.unit_us);
             } 
         case 20:
             close_560();
             exit(0);
             break;
         default:
             printf ("Invalid option\n");
             break;
         } 
     }
}
